//
//  KeyboardScene.cpp
//  layer_keyboard
//
//  Created by Reza Ghobadinic on 2019-09-08.
//

#include "KeyboardScene.h"
#include <iostream>

USING_NS_CC;

Scene* KeyboardScene::createScene()
{
    auto scene = Scene::create();
    auto layer = KeyboardScene::create();
    
    scene->addChild(layer);
    
    return scene;
}

bool KeyboardScene::init()
{
    auto visibleSize = Director::getInstance()->getVisibleSize();
    Vec2 origin = Director::getInstance()->getVisibleOrigin();
    
    x = origin.x + visibleSize.width / 2;
    y = origin.y + visibleSize.height / 2;
    
    auto sprite = Sprite::create("Box.png");
    sprite->setPosition(x, y);
    this->addChild(sprite, 0, 1); // Add the sprite as a child with tag = 1
    
    auto listener = EventListenerKeyboard::create();                           // Create a keyboard listener
    listener->onKeyPressed = CC_CALLBACK_2(KeyboardScene::onKeyPressed, this); // Assign a callback to onKeyPressed event
    _eventDispatcher->addEventListenerWithSceneGraphPriority(listener, this);  // Add the listener to the event dispatcher
    
    return true;
}

void KeyboardScene::onKeyPressed(EventKeyboard::KeyCode keyCode, Event* event)
{
    float translate = 2.0;
    switch(keyCode){
        case EventKeyboard::KeyCode::KEY_LEFT_ARROW:
            x -= translate;
            break;
        case EventKeyboard::KeyCode::KEY_RIGHT_ARROW:
            x += translate;
            break;
        case EventKeyboard::KeyCode::KEY_UP_ARROW:
            y += translate;
            break;
        case EventKeyboard::KeyCode::KEY_DOWN_ARROW:
            y -= translate;
            break;
        default:
            break;
    }
    auto sprite = this->getChildByTag(1); // Retrieve the sprite using the tag
    sprite->setPosition(x, y);
    
    CCLOG("Code: %d, x= %f, y= %f", keyCode, x, y);
}
